<template>
  <div>
    <default-spinner-component :loading-message="loadingMessage"
      v-if="loadingData"/>
      <div v-if="loadedData">
        <v-container style="margin-top: -30px;">
          <v-layout row
            justify-space-around
            v-bind="gridResponsiveness">
            <v-flex xs4 style="margin-top:20px;">
              <v-card id="detailsContent"
                class="defaultCardBackground"
                style="width:98%;margin:0 auto;">
                <v-card-title style="padding:0px 0px 0px 16px;">
                  <h4 style="color:#4f8196">
                    Seller information
                  </h4>
                  <v-spacer></v-spacer>
                  <v-btn icon
                    style="color:#4f8196;"
                    @click.native.stop="editDialog = true">
                    <v-icon>
                      edit
                    </v-icon>
                  </v-btn>
                  <v-btn icon
                    @click.native.stop="dialog = true">
                    <v-icon style="color:#4f8196">
                      delete
                    </v-icon>
                  </v-btn>
                </v-card-title>
                <v-divider></v-divider>
                <ul class="sellerDetailListItem"
                  style="padding-top:0px;">
                  <li>
                    <span class="detailLabel">
                      Name
                    </span>
                    &nbsp;&nbsp;{{sellerInformation.firstName}} {{sellerInformation.middleName}} {{sellerInformation.lastName}}
                  </li>
                  <li>
                    <span class="detailLabel">
                      Registered date
                    </span>
                    &nbsp;&nbsp;{{sellerInformation.registeredDate}}
                  </li>
                  <li>
                    <span class="detailLabel">
                      Total products sold
                    </span>
                    &nbsp;&nbsp;{{sellerInformation.numberOfItemsSold}}
                  </li>
                  <li>
                    <span class="detailLabel">
                      Total money of sold products
                    </span>
                    &nbsp;&nbsp;{{sellerInformation.totalSold}}
                  </li>
                  <li>
                    <span class="detailLabel">
                      Total money of earned
                    </span>
                    &nbsp;&nbsp;{{sellerInformation.totalEarned}}
                  </li>
                  <li>
                    <span class="detailLabel">
                      Shop
                    </span>
                    &nbsp;&nbsp;{{sellerInformation.sellerShopName}}
                  </li>
                </ul>
              </v-card>
            </v-flex>
            <v-flex xs8
              style="margin-top:20px;">
              <v-card id="detailsContent"
                class="defaultCardBackground"
                style="width:98%;margin:0 auto">
              </v-card>
            </v-flex>
          </v-layout>
          <v-layout row
            justify-space-between
            v-bind="gridResponsiveness">
            <v-flex xs4
              style="margin-top:20px;">
              <v-card id="detailsContentSecondary"
                class="defaultCardBackground"
                style="width:98%;margin: 0 auto;height:200px !important;">
                <v-layout row
                  justify-space-between>
                  <v-flex xs6 style="border-right:1px solid #BDBDBD;height:200px;">
                    <div class="salesSummaryTopContainer">
                      <span class="summaryMessageText"
                        style="margin-left:30px;margin-top:35px;">
                        Total sales
                      </span>
                      <span class="summaryValue"
                        style="margin-left:30px;margin-top:45px;">
                        {{totalSales}}
                      </span>
                    </div>
                    <div class="salesSummaryTopContainer"
                      style="border-bottom:none;">
                      <span class="summaryMessageText"
                        style="margin-top:25px;margin-left:30px;">
                        Total profit
                      </span>
                      <span class="summaryValue"
                        style="color:#3bbcd4;margin-top:35px;margin-left:30px;">
                        {{totalSales - totalCost}}
                      </span>
                    </div>
                  </v-flex>
                  <v-flex xs6>
                    <div class="salesSummaryTopContainer">
                      <span class="summaryMessageText"
                        style="margin-left:30px;margin-top:35px;">
                        Total cost
                      </span>
                      <span class="summaryValue"
                        style="margin-left:30px;margin-top:45px;">
                        {{totalCost}}
                      </span>
                    </div>
                    <div class="salesSummaryTopContainer"
                      style="border-bottom:none;">
                      <span class="summaryMessageText"
                        style="margin-top:25px;margin-left:30px;">
                        Profit %
                      </span>
                      <span class="summaryValue"
                        style="color:#3bbcd4;margin-top:35px;margin-left:30px;">
                        {{Math.round((totalCost * 100)/totalSales)}}%
                      </span>
                    </div>
                  </v-flex>
                </v-layout>
              </v-card>
            </v-flex>
            <v-flex xs8
              style="margin-top:20px;">
              <v-card id="detailsContentSecondary"
                class="defaultCardBackground"
                style="width:98%;margin:0 auto;">
                <v-data-table
                  :headers="headers"
                  :items="sellerSalesInformation"
                  hide-actions>
                  <template slot="items" slot-scope="props">
                    <td>
                      {{ props.item.time}}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.name }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.salesPrice }}
                    </td>
                  </template>
                </v-data-table>
              </v-card>
            </v-flex>
          </v-layout>
          <v-dialog v-model="dialog" max-width="400">
            <v-card style="background:#FFEBEE">
              <v-progress-linear
                v-if="deleteRequested"
                :indeterminate="true"
                height="4"
                color="success"
                background-color="lightSuccess"
                style="height: 4px;position: absolute;top: -16px;">
              </v-progress-linear>
              <v-card-title>
                <h4 style="color:#4f8196">
                  Are you shure you want to delete {{sellerInformation.firstName}} {{sellerInformation.middleName}}?
                </h4>
              </v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="darkSecondary"
                  depressed
                  dark
                  @click.native="dialog = false">
                  CANCEL
                </v-btn>
                <v-btn outline
                  color="error"
                  @click="deleteUserClicked">
                  DELETE
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-dialog v-model="editDialog"
            persistent
            max-width="500px">
            <v-card style="height: auto;width: auto;overflow-y: auto;">
              <v-progress-linear
                v-if="submitRequested"
                :indeterminate="true"
                height="4"
                color="success"
                background-color="lightSuccess"
                style="height: 4px;position: absolute;top: -16px;">
              </v-progress-linear>
              <v-card-title style="padding:0px 16px 0px 16px;">
                <h4 style="color:#4f8196">
                  Edit seller
                </h4>
                <v-spacer></v-spacer>
                <v-btn icon
                  style="color:#757575"
                  @click.native.stop="editDialog = false">
                  <v-icon>
                    close
                  </v-icon>
                </v-btn>
              </v-card-title>
              <v-divider></v-divider>
              <form style="width:97%;margin-top:-10px;"
                @submit.prevent="$v.$touch(); editUserClicked();">
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.firstName.$error }">
                  <input id="firstName"
                    class="inputDefault"
                    type="text"
                    v-model.trim="firstName"
                    @input="$v.firstName.$touch()"
                    v-on:input="$v.firstName.$touch"
                    v-bind:class="{
                      error: $v.firstName.$error,
                      valid: $v.firstName.$dirty && !$v.firstName.$invalid
                    }"/>
                  <label for="firstName"
                    class="defaultInputPlaceholder">
                    First name
                  </label>
                  <span class="formErrorMessage"
                    v-if="$v.firstName.$error && $v.firstName.$dirty">
                    Required
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.firstName.$dirty && !$v.firstName.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.firstName.$error && $v.firstName.$dirty">
                    cancel
                  </v-icon>
                </div>
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.middleName.$error }">
                  <input id="middleName"
                    class="inputDefault"
                    type="text"
                    v-model.trim="middleName"
                    @input="$v.middleName.$touch()"
                    v-on:input="$v.middleName.$touch"
                    v-bind:class="{
                      error: $v.middleName.$error,
                      valid: $v.middleName.$dirty && !$v.middleName.$invalid
                    }"/>
                  <label for="middleName"
                    class="defaultInputPlaceholder">
                    Middle name
                  </label>
                  <span class="formErrorMessage"
                    v-if="$v.middleName.$error && $v.middleName.$dirty">
                    Required
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.middleName.$dirty && !$v.middleName.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.middleName.$error && $v.middleName.$dirty">
                    cancel
                  </v-icon>
                </div>
                <div class="defaultInputContainer"
                  v-bind:class="{ 'form-group--error': $v.lastName.$error }">
                  <input id="lastName"
                    class="inputDefault"
                    type="text"
                    v-model.trim="lastName"
                    @input="$v.lastName.$touch()"
                    v-on:input="$v.lastName.$touch"
                    v-bind:class="{
                      error: $v.lastName.$error,
                      valid: $v.lastName.$dirty && !$v.lastName.$invalid
                    }"/>
                  <label for="lastName"
                    class="defaultInputPlaceholder">
                    Last name
                  </label>
                  <span class="formErrorMessage"
                    v-if="$v.lastName.$error && $v.lastName.$dirty">
                    Required
                  </span>
                  <v-icon style="color:#5A5"
                    v-if="$v.lastName.$dirty && !$v.lastName.$invalid">
                    check_circle
                  </v-icon>
                  <v-icon style="color:#FF6E40"
                    v-if="$v.lastName.$error && $v.lastName.$dirty">
                    cancel
                  </v-icon>
                </div>
                <br/>
                <v-btn block
                  depressed
                  dark
                  color="darkSecondary"
                  type="submit"
                  style="width: 90%;margin: 0 auto;">
                    UPDATE Seller
                </v-btn>
                <br/><br/>
              </form>
            </v-card>
          </v-dialog>
        </v-container>
      </div>
  </div>
</template>
<script>
import axios from 'axios'
import DefaultSpinnerComponent from './../common/spinner.vue'
import { required } from 'vuelidate/lib/validators'
import moment from 'moment'
export default {
  name: 'ViewSellerComponent',
  data: () => ({
    loadingData: true,
    loadedData: false,
    sellerInformation: {},
    dialog: false,
    editDialog: false,
    deleteRequested: false,
    submitRequested: false,
    firstName: undefined,
    middleName: undefined,
    lastName: undefined,
    editableSellerInfo: {},
    sellerSalesInformation: [],
    headers: [
      {
        text: 'Time',
        align: 'left',
        sortable: false,
        value: 'name'
      },
      { text: 'Item name', value: 'name', sortable: false },
      { text: 'Sales price', value: 'salesPrice', sortable: true }
    ]
  }),
  components: {
    DefaultSpinnerComponent
  },
  computed: {
    loadingMessage () {
      return 'Loading ' + this.$route.params.id + '\'s Data'
    },
    totalSales () {
      let salesPrice = 0
      this.sellerSalesInformation.forEach(element => {
        salesPrice = salesPrice + element.salesPrice
      })
      return salesPrice
    },
    totalCost () {
      let expectedPrice = 0
      this.sellerSalesInformation.forEach(element => {
        expectedPrice = expectedPrice + element.expectedPrice
      })
      return expectedPrice
    },
    totalProfit () {
      let expectedPrice = 0
      let salesPrice = 0
      this.sellerSalesInformation.forEach(element => {
        expectedPrice = expectedPrice + element.expectedPrice
        salesPrice = salesPrice + element.salesPrice
      })
      return salesPrice - expectedPrice
    },
    profitPercentage () {
      let expectedPrice = 0
      let salesPrice = 0
      this.sellerSalesInformation.forEach(element => {
        expectedPrice = expectedPrice + element.expectedPrice
        salesPrice = salesPrice + element.salesPrice
      })
      return Math.round((expectedPrice * 100) / salesPrice)
    },
    gridResponsiveness () {
      const gridResponsiveness = {}
      if (this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs) gridResponsiveness.column = true
      return gridResponsiveness
    },
    smallGridResponsiveness () {
      const gridResponsiveness = {}
      if (this.$vuetify.breakpoint.xs) gridResponsiveness.column = true
      return gridResponsiveness
    }
  },
  methods: {
    deleteUserClicked () {
      this.deleteRequested = true
      axios.delete('seller/' + this.sellerInformation.firstName)
        .then(response => {
          setTimeout(() => {
            this.deleteRequested = false
            this.dialog = false
            this.loadedData = false
            this.$store.commit('SHOW_SUCCESS_SNACK_BAR', 'Seller ' + this.$route.params.id + ' is succefully deleted')
          }, 2000)
        })
        .catch(error => {
          this.deleteRequested = false
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured on seller deletion: ' + error)
        })
    },
    editUserClicked () {
      this.submitRequested = true
      this.editableSellerInfo.firstName = this.firstName
      this.editableSellerInfo.middleName = this.middleName
      this.editableSellerInfo.lastName = this.lastName
      axios.put('seller/' + this.sellerInformation._id, this.editableSellerInfo)
        .then(response => {
          setTimeout(() => {
            this.submitRequested = false
            this.editDialog = false
            this.$store.commit('SHOW_SUCCESS_SNACK_BAR', 'User ' + this.$route.params.id + ' is succefully updated')
          }, 2000)
        })
        .catch(error => {
          this.submitRequested = false
          this.editDialog = false
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured on user edit: ' + error)
          this.editableUser = this.userInformation
        })
    },
    populateData () {
      this.loadingData = true
      this.loadedData = false
      let separatedName = this.$route.params.id.split(' ')
      axios.get('seller/' + separatedName[0])
        .then(response => {
          this.sellerInformation = response.data
          this.sellerInformation.registeredDate = moment(response.data.registeredDate).format('YYYY-MM-DD HH:mm')
          this.editableSellerInfo = response.data
          this.firstName = this.sellerInformation.firstName
          this.middleName = this.sellerInformation.middleName
          this.lastName = this.sellerInformation.lastName
          return axios.get('sales/' + separatedName[0])
        }, error => {
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured on getting the seller information: ' + error)
        })
        .then(response => {
          setTimeout(() => {
            this.sellerSalesInformation = response.data.map(element => {
              let rawData = element
              rawData.time = moment(element.time).format('YYYY-MM-DD HH:mm')
              return rawData
            })
            this.loadingData = false
            this.loadedData = true
          }, 2000)
        }, error => {
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured on getting the sales information: ' + error)
        })
    }
  },
  watch: {
    '$route' (to, from) {
      this.populateData()
    }
  },
  created () {
    this.populateData()
  },
  validations: {
    firstName: {
      required
    },
    middleName: {
      required
    },
    lastName: {
      required
    }
  }
}
</script>
<style scoped>
  #detailsContent{
  display: block;
  margin: 0;
  min-height: 270px !important;
  height: auto !important;
  }
  #detailsContentSecondary{
  display: block;
  margin: 0;
  height: 350px !important;
  overflow-y: auto;
  }
  #tableElements{
    padding: 24px !important;
  }
</style>
